format PE console

entry Start

include "decl.inc"

proc Start
    locals
	tCounters VM_COUNTERS64 ?
	dwWritten dd ?
	pfn dd ?
    endl

    cld

    stdcall GetNtDllHandle ; Get ntdll64 handle
    stdcall GetProcAddrress64, eax, 'NtQueryInformationProcess' ; get 64 bit fn

    .if eax
	mov [pfn], eax
	@@:
	ccall X64Call, [pfn], 5, -1, ProcessVmCounters, addr tCounters, sizeof.VM_COUNTERS64, addr dwWritten
	jmp @b
    .endif

endp

; Call 64 bit function
proc X64Call c uses ebx edi, pfn, lNumArgs

    jmp far 0x33:@f

use64

    @@:

    push rsi	  ; Save stack
    mov rsi, rsp

    mov ebx, [lNumArgs]

    .if ebx < 4
	mov ebx, 4
    .endif

    inc ebx
    and ebx, -2
    and rsp, -16
    neg ebx
    lea esp, [esp + ebx * 8]

    mov ebx, [lNumArgs]
    lea eax, [lNumArgs + ebx * 4] ; last arg

    .while ebx

	dec ebx

	.if ebx = 0
	    movsxd rcx, dword [eax]
	.elseif ebx = 1
	    movsxd rdx, dword [eax]
	.elseif ebx = 2
	    movsxd r8, dword [eax]
	.elseif ebx = 3
	    movsxd r9, dword [eax]
	.else
	    movsxd rdi, dword [eax]
	    mov [rsp + rbx*8], rdi
	.endif

	sub eax, 4

    .endw

    mov eax, [pfn]
    call rax
    mov rdx, rax
    shr rdx, 0x20

    mov rsp, rsi  ; Restore stack
    pop rsi

use32

    jmp far [0]
    dd @f
    dw 0x23
    @@:

    ret

endp

; GetProcAddress64
proc GetProcAddrress64 uses esi edi ebx, hLib, sFuncName

    mov ebx, [hLib]
    mov eax, [ebx + 0x3c]
    mov eax, [eax + 0x88 + ebx]  ; Export dir
    add eax, ebx
    mov ecx, [eax + 0x18]  ; Num of functions
    mov edx, [eax + 0x20]  ; Names

    @@:

	mov edi, [edx + ebx]

	.if edi

	    add edi, ebx
	    xchg esi, eax
	    push ecx
	    xor eax, eax
	    lea ecx, [eax - 1]
	    repne scasb
	    not ecx
	    sub edi, ecx
	    xchg esi, eax
	    mov esi, [sFuncName]
	    repe cmpsb
	    pop ecx

	    .if ZERO?

		sub ecx, [eax + 0x18]
		neg ecx
		mov edx, [eax + 0x24]
		add edx, ebx
		movzx edx, word [edx + ecx * 2]
		mov eax, [eax + 0x1c]
		add eax, ebx
		mov eax, [eax + edx * 4]
		add eax, ebx
		jmp .exit_function

	    .endif

	.endif

	add edx, 4

    loop @b

    xor eax, eax

.exit_function:

    ret

endp

; Get 64 bit ntdll base address
proc GetNtDllHandle
    locals
	tPBI PROCESS_BASIC_INFORMATION64 ?
	dwRead dw ?
	pPEBLdr dq ?
    endl

    invoke NtWow64QueryInformationProcess64, -1, ProcessBasicInformation, addr tPBI, \
					     sizeof.PROCESS_BASIC_INFORMATION64, addr dwRead

    .if eax < 0
	ret
    .endif

    mov eax, dword [tPBI.PebBaseAddress]
    mov eax, [eax + 0x18] ; PEB->Ldr
    mov eax, [eax + 0x10] ; PEB_LDR_DATA.InLoadOrderModuleList.Flink <- exe
    mov eax, [eax] ; <- ntdll
    mov eax, [eax + 0x30] ; <- BaseAddress

    ret

endp